
import java.awt.*;
import javax.swing.*;
import java.awt.print.*;
import java.awt.event.*;

public class Window extends JPanel implements Printable {

   final int Width = 1024,  Height = 780;
   String[][] names;
   Color color = Color.blue;
   JButton print;   //array of safe colors to display
   Color[] colors = {new Color(255, 102, 51), Color.black, Color.blue, Color.green, new Color(204, 153, 0), new Color(51, 0, 102), new Color(204, 51, 204)};
   //start counter randomly
   int counter = (int) (Math.random() * colors.length);

   public Window(String[][] x, boolean p) {
      this.setLayout(new BorderLayout());
      names = x;//copies array


      if (p == true) {
         print = new JButton("Print Bracket");
         print.addActionListener(new ActionListener() {

            public void actionPerformed(ActionEvent e) {

               //if clicked
               //remove print button from view
               remove(print);
               //print
               p();
               //add the print button into view again
               add(print, BorderLayout.NORTH);
            }
         });

         //add the print button at the top 
         add(print, BorderLayout.NORTH);
      }

      setBackground(Color.white);
      setPreferredSize(new Dimension(Width, Height));

   }

   public void paintComponent(Graphics g) {
      super.paintComponent(g);

      Font font = new Font("Monospaced", Font.PLAIN, 12);
      FontMetrics fontm = g.getFontMetrics(font);

      int down = 30, olddown = 30, right = 20;
      int deltadown = 20;
      int deltaright = 250;
      int fontHeight = fontm.getHeight();

      //looks at our whole array for values
      for (int i = 0; i < 12; ++i) {
         for (int j = 0; j < 12; j++) {


            if (names[i][j] != null) {

               //if this is a match (there is two people in a match
               if (j % 2 == 0) {
                  //set to a different safe color
                  color = colors[counter % colors.length];

                  //safety  to not overflow int
                  if (counter > 1000) {
                     counter = (int) (Math.random() * colors.length);
                  } else {
                     counter++;
                  }
               }

               //sets match color and draws name
               g.setColor(color);
               g.drawString(names[i][j], right, down);


               //sets the color to black for the lines
               g.setColor(Color.black);

               if (!(names[i][0] != null && (names[i][1] == null || names[i][1] == null))) {
                  if (names[i][j] != null) {
                     //get the witdh of the name to obtain coordinate
                     int width = fontm.stringWidth(names[i][j]);

                     //draw a line from end of name to the middle of the space
                     //inbetween the next colum
                     g.drawLine(right + width, down - fontHeight / 4, right + deltaright / 2, down - fontHeight / 4);
                  }


                  //big if used to end here


                  //if this is the fist copetitor in a match and had a rival
                  //draw the line connecting it to the rival
                  if ((j % 2 == 0 && names[i][j + 1] != null) && names[i][j + 1] != null) {
                     g.drawLine(right + deltaright / 2, down - fontHeight / 4, right + deltaright / 2, down + deltadown - fontHeight / 4);
                  }
               }//end if

            }//end big if
            else {
               continue;
            //move down for  new name
            }
            down += deltadown;
         }//end for

         //sets stagered coordinates
         down = olddown + deltadown / 2;
         olddown = down;
         deltadown *= 2;

         right += deltaright;
      }//end big for

   }
   //Function that handles the printing
   public int print(Graphics g, PageFormat pf, int page) throws
      PrinterException {

      //if there is nothing to print return
      if (page > 0) {
         return NO_SUCH_PAGE;
      }

      //translate  our coordinate system
      //not really worried about scaling since a printers resolution is high
      Graphics2D g2d = (Graphics2D) g;
      g2d.translate(pf.getImageableX(), pf.getImageableY());

      //print visible components of our JPanel
      this.printAll(g);

      return PAGE_EXISTS;
   }
   //Method to be called to print
   public void p() {
      //creates job
      PrinterJob job = PrinterJob.getPrinterJob();
      //sets the frame printable
      job.setPrintable(this);
      boolean ok = job.printDialog();
      if (ok) {
         try {//trys to print using print() function
            job.print();
         } catch (PrinterException ex) {
         }
      }
   }
}//end class
